;-------------------------------------------------------------------------------
;Wilder Randomness 1.0
;
;Randomly advances the indexes used to get random numbers every 1/60 of one
; second in game. It turns the random numbers obtained more unpredictable.
;-------------------------------------------------------------------------------

header
hirom

;-------------------------------------------------------------------------------
;link
;-------------------------------------------------------------------------------
org     $C3140D

        ;link new code
        JSR random_updater

warnpc  $C31410

;-------------------------------------------------------------------------------
;random updater
;
;randomly increases indexes used by random number generators
;-------------------------------------------------------------------------------
org     $C3F900             ;(*) change for any free space
print   "seg start: ", pc

random_updater:

        ;original code
        INC $021E           ;increment frame

        ;get random value
        LDA $213F           ;set lower byte to latch
        LDA $2137           ;prepare latch of H/V counter
        LDA $213C           ;pseudo-random: get H counter
        ADC $213D           ;pseudo-random: add V counter

        ;update random index 1: related to main purposes
        .case1_start
        LSR
        BCS .case1_end
        INC $1F6D
        .case1_end

        ;update random index 2: related to overworld
        .case2_start
        LSR
        BCS .case2_end
        INC $1FA1
        .case2_end

        ;update random index 3: related to dungeons/towns
        .case3_start
        LSR
        BCS .case3_end
        INC $1FA2
        .case3_end

        ;update random index 4: related to veldt 
        .case4_start
        LSR
        BCS .case4_end
        INC $1FA5
        .case4_end

        ;exit
        RTS

print   "seg end  : ", pc
